SystemOrganization addCategory: #ConfigurationOfSmallchange!

Object subclass: #ConfigurationOfSmallchange
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfSmallchange'!

!ConfigurationOfSmallchange class methodsFor: 'development support' stamp: 'StuartHerring 2/12/2012 13:31'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfSmallchange class methodsFor: 'private' stamp: 'StuartHerring 2/12/2012 13:31'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfSmallchange class methodsFor: 'private' stamp: 'StuartHerring 2/12/2012 13:31'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfSmallchange class methodsFor: 'private' stamp: 'StuartHerring 2/12/2012 13:31'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfSmallchange class methodsFor: 'metacello tool support' stamp: 'StuartHerring 2/12/2012 13:31'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfSmallchange class methodsFor: 'loading' stamp: 'StuartHerring 2/12/2012 13:31'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfSmallchange class methodsFor: 'loading' stamp: 'StuartHerring 2/12/2012 13:31'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfSmallchange class methodsFor: 'loading' stamp: 'StuartHerring 2/12/2012 13:31'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfSmallchange class methodsFor: 'accessing' stamp: 'StuartHerring 2/12/2012 13:31'!
project

	^self new project! !

!ConfigurationOfSmallchange class methodsFor: 'development support' stamp: 'StuartHerring 2/12/2012 13:31'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfSmallchange methodsFor: 'baselines' stamp: 'StuartHerring 2/12/2012 18:22'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.stuartherring.net/mc/Smallchange'.
		spec 
			project: 'Mabinogi' with: [
				spec
					className: 'ConfigurationOfMabinogi';
					versionString: #'bleedingEdge';
					repository: 'http://stuartherring.net/mc/Mabinogi' ];
			project: 'Seaside30' with: [
				spec
					className: 'ConfigurationOfSeaside30';
					versionString: #'stable';
					repository: 'http://www.squeaksource.com/MetacelloRepository';
					loads: #('Base' 'JQuery-Core') ];
		 	project: 'Seaside30 Development' copyFrom: 'Seaside30' with: [
				spec
					loads: 'Development'];
			project: 'Mocketry' with: [
				spec
					className: 'ConfigurationOfMocketry';
					versionString: #'stable';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'Seaside Testing' with: [
				spec
					className: 'ConfigurationOfSeasideTesting';
					versionString: '0.7';
					repository: 'http://www.squeaksource.com/SeasideTesting';
					loads: 'SimulatedBrowserTesting' ];
			project: 'SIXX' with: [
				spec
					className: 'ConfigurationOfSIXX';
					versionString: '0.3.6';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec 
			package: 'Smallchange-Core' with: [
				spec requires: #('Mabinogi' ). ];
			package: 'Smallchange-Web' with: [
				spec requires: #('Smallchange-Core' 'Seaside30' 'SIXX' ). ];
			package: 'Smallchange-Test' with: [
				spec requires: #('Smallchange-Core' 'Smallchange-Web' 'Mocketry' 'Seaside Testing' ). ].
		spec 
			group: 'default' with: #('Development' );
			group: 'Core' with: #('Smallchange-Core' 'Smallchange-Web' );
			group: 'Tests' with: #('Smallchange-Test' );
			group: 'Development' with: #('Core' 'Tests' 'Seaside30 Development' ). ].
! !

!ConfigurationOfSmallchange methodsFor: 'baselines' stamp: 'StuartHerring 3/27/2012 15:51'!
baseline02: spec
	<version: '0.2-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec description: 'Creating new baseline to add dependency on Khmai-Platform'.
		spec repository: 'http://www.stuartherring.net/mc/Smallchange'.
		spec 
			project: 'Mabinogi' with: [
				spec
					className: 'ConfigurationOfMabinogi';
					versionString: #'bleedingEdge';
					repository: 'http://stuartherring.net/mc/Mabinogi';
					loads: #('Core') ];
			project: 'Mabinogi Web' copyFrom: 'Mabinogi' with: [
				spec loads: #('Full') ];
			project: 'Mabinogi Test' copyFrom: 'Mabinogi' with: [
				spec loads: #('Tests') ];
			project: 'Khami Platform' with: [
				spec
					className: 'ConfigurationOfVillagesOfKhami';
					versionString: #'bleedingEdge';
					repository: 'http://stuartherring.net/mc/Khami';
					loads: #('Platform') ];
			project: 'Khami Platform Tests' copyFrom: 'Khami Platform' with: [
				spec loads: #('Platform Test') ];
			project: 'Seaside30' with: [
				spec
					className: 'ConfigurationOfSeaside30';
					versionString: #'stable';
					loads: #('Base' 'JQuery-Core' 'Seaside-HTML5');
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'Seaside30 Development' copyFrom: 'Seaside30' with: [
				spec loads: #('Development' ) ];
			project: 'Mocketry' with: [
				spec
					className: 'ConfigurationOfMocketry';
					versionString: #'stable';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'Seaside Testing' with: [
				spec
					className: 'ConfigurationOfSeasideTesting';
					versionString: '0.7';
					loads: #('SimulatedBrowserTesting' );
					repository: 'http://www.squeaksource.com/SeasideTesting' ];
			project: 'SIXX' with: [
				spec
					className: 'ConfigurationOfSIXX';
					versionString: '0.3.6';
					repository: 'http://www.squeaksource.com/MetacelloRepository';
					loads: #('Core') ].
		spec 
			package: 'Smallchange-Core' with: [
				spec requires: #('Mabinogi' ). ];
			package: 'Smallchange-Dev' with: [
				spec requires: #('Smallchange-Core' 'Seaside30 Development')	];
			package: 'Smallchange-Web' with: [
				spec requires: #('Khami Platform' 'Mabinogi Web' 'Smallchange-Core' 'Seaside30' 'SIXX' ). ];
			package: 'Smallchange-Test' with: [
				spec requires: #('Seaside Testing' 'Smallchange-Core' 'Smallchange-Web' 'Khami Platform Tests' 'Mabinogi Test' 'Mocketry'). ].
		spec 
			group: 'default' with: #('Development' );
			group: 'Core' with: #('Smallchange-Core' 'Smallchange-Web' );
			group: 'Tests' with: #('Smallchange-Test' );
			group: 'Development' with: #('Core' 'Tests' 'Smallchange-Dev' ). ].
! !

!ConfigurationOfSmallchange methodsFor: 'symbolic versions' stamp: 'StuartHerring 2/15/2012 20:14'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.2'.
! !

!ConfigurationOfSmallchange methodsFor: 'accessing' stamp: 'StuartHerring 2/12/2012 13:31'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfSmallchange methodsFor: 'symbolic versions' stamp: 'StuartHerring 2/15/2012 20:13'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '0.1'.
! !

!ConfigurationOfSmallchange methodsFor: 'versions' stamp: 'StuartHerring 2/15/2012 20:13'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'initial version
SC-10
Added announcement based #openModal: method used to signal the root class to display a dialogue.
Added tests using SeasideTesting to ensure that the answer is not lost.
Implemented New Account and New Pool dialogues. (Autogenerated at the moment)

SC-14
Made use of the new MbTable component to build the transaction list.
It''s ugly and rough at the moment, but the information is there, which is the important thing.
Also made the undo history a bit more attractive.
SC-4
Implemented Transfer support by giving Transactions a sourcePool and sourceAccount.

SC-16, SC-10
Added support for editing Transactions and Accounts/Pools via MbUpdateDefinedObjectCommand
'.
		spec author: 'StuartHerring'.
		spec timestamp: '2/15/2012 20:03'.
		spec project: 'Mabinogi' with: '0.1'.
		spec 
			package: 'Smallchange-Core' with: 'Smallchange-Core-StuartHerring.8';
			package: 'Smallchange-Web' with: 'Smallchange-Web-StuartHerring.6';
			package: 'Smallchange-Test' with: 'Smallchange-Test-StuartHerring.4'. ].
! !

!ConfigurationOfSmallchange methodsFor: 'versions' stamp: 'StuartHerring 4/10/2012 15:44'!
version02: spec
	<version: '0.2' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: ' - opening for milestone 2 work
SC-15
Initial RGraph support added

SC-5, SC-18, SC-19
Implemented support for Magma persistence, added Bootstrap support and integrated with login process
SC-18
Updated ScwSession so that new accounts get created on login if they don''t already exist
SC-41
Fixed problem with last transaction appearing to not persist.  It actually did persist, but dueto being a magma proxy, it failed the comparison in #ownsTransaction:.
Fixed #ownsTransaction: implementations to use = not == (not sure why I did that in the first place)
SC-32
Modify model so that fields are now declared via the <mbFields: > pragma, rather than implied.
SC-29
First support for Scheduled transactions implemented - implemented some basic predictions as a proof of concept
SC-29
Replace automatic detection with explicit declaration via an <embed> pragma.  Auto detection was causing weird effects
SC-28
Switch implementation to keep track of pending transactions in Profile rather than try to determine it on the fly from the schedules.
Also moved the checkpoint into Profile rather than in each Schedule
SC-28
Completed implementation - added ability to accept, edit and delete pending transactions
SC-22
	Simplistic warning implemented for running out of money in your accounts
SC-22
	Added test for pools too, and improved the logic to ensure that the cumulative effect of multiple bills are taken into account
Minor fix to "All Transactions" view
SC-34 
Mostly implemented automatic transaction behaviour, as well as adding the ScTimetable classes which are used for converting between different types of schedules.  Still need to handle manual allocations as well as separating automated allocations from transfers
SC-34 
Fixed analysers to take automatic transactions into account, also made auto transactins rounded to nearest cent.
Still need to handle manual allocations as well as separating automated allocations from transfers
SC-34 
Some minor tweaks to the analysers so they don''t report false positives.
Also use a readStrategy to ensure that Schedule transactions are fully loaded
SC-34 
Split automated transactions into separate batches for pools and accounts, and consolidated them
SC-43, SC-44
Implemented manualTransaction support, and added migration capability to Profile to make it easy to modify the schema in the future
SC-33
Added UI for manual transactions
SC-33
Charts added.  That''s enough for now
SC-27, SC-24
Added User Profile screen, and delete user functionality.  Need to do a little more work on the user details section
Split the pending transactions plugin out into a new "Dev" package so that the core image doesn''t need to depend on Seaside Development
Fixed test failures that were happening due to having decided to go with a simple 365 days in a year
Ensure Seaside-HTML5 is pulled in
SC-46
Implemented delete for schedule items.
Also fixed a minor issue with yearly timetables.

SC-24, SC-26
Working towards correct registration process - includes removing the separate profile registry and instead just making profile a property
of user.  There''s a new ScUser which uses to new Mabinogi Trait to both be an MbObject and be an SPUser'.
		spec author: 'StuartHerring'.
		spec timestamp: '4/10/2012 15:44'.
		spec project: 'Mabinogi' with: '0.2'.
		spec 
			package: 'Smallchange-Core' with: 'Smallchange-Core-StuartHerring.26';
			package: 'Smallchange-Web' with: 'Smallchange-Web-StuartHerring.27';
			package: 'Smallchange-Dev' with: 'Smallchange-Dev-StuartHerring.1';
			package: 'Smallchange-Test' with: 'Smallchange-Test-StuartHerring.18'. ].
! !
